| Home | Libraries | People | FAQ | More

#### params_encoded_ref

A view representing query parameters in a URL.

##### Synopsis

Defined in header `<boost/url/params_encoded_ref.hpp>`

    class params_encoded_ref :
        public params_encoded_base

##### Types

Name | Description
--- | ---
const_iterator | A Bidirectional iterator to a query parameter.
const_reference | The reference type.
difference_type | A signed integer type used to represent differences.
iterator | A Bidirectional iterator to a query parameter.
reference | The reference type.
size_type | An unsigned integer type to represent sizes.
value_type | The value type.

##### Member Functions

Name | Description
--- | ---
append | Append params.
assign | Assign params.
begin | Return an iterator to the beginning.
buffer | Return the query corresponding to these params.
clear | Clear the contents of the container.
contains | Return true if a matching key exists.
count | Return the number of matching keys.
empty | Return true if there are no params.
end | Return an iterator to the end.
erase | Erase params.
find | Find a matching key.
find_last | Find a matching key.
insert | Insert params.
operator= | Assignment.
operator params_encoded_view | Conversion.
params_encoded_ref [constructor] | Constructor.
replace | Replace params.
set | Set a value.
size | Return the number of params.
unset | Remove the value on an element.
url | Return the referenced url.

##### Static Member Functions

Name | Description
--- | ---
max_size | Return the maximum number of characters possible.

##### Description

Objects of this type are used to interpret the query parameters as a bidirectional view of key value pairs. The view does not retain ownership of the elements and instead references the original url. The caller is responsible for ensuring that the lifetime of the referenced url extends until it is no longer referenced. The view is modifiable; calling non-const members causes changes to the referenced url.

##### Example

    url u( "?first=John&last=Doe" );

    params_encoded_ref p = u.encoded_params();

Strings produced when elements are returned have type `param_pct_view` and represent encoded strings. Strings passed to member functions may contain percent escapes, and throw exceptions on invalid inputs.

##### Iterator Invalidation

Changes to the underlying character buffer can invalidate iterators which reference it. Modifications made through the container invalidate some iterators to the underlying character buffer: * `append` : Only `end()`. * `assign`, `clear`, `operator=` : All params. * `erase` : Erased params and all params after (including `end()`). * `insert` : All params at or after the insertion point (including `end()`). * `replace`, `set` : Modified params and all params after (including `end()`).

Convenience header `<boost/url.hpp>`